| Pattern                                                                              | Category               | Tags                              |
| :---                                                                                 | :---                   | :---                              |
| [Abstract Document](abstract-document)                                               | Structural             | Extensibility                     |
| [Abstract Factory](abstract-factory)                                                 | Creational             | Gang of Four                      |
| [Active Object](active-object)                                                       | Concurrency            | Performance                       |
| [Acyclic Visitor](acyclic-visitor)                                                   | Behavioral             | Extensibility                     |
| [Adapter](adapter)                                                                   | Structural             | Gang of Four                      |
| [Aggregator Microservices](aggregator-microservices)                                 | Architectural          | Cloud distributed                 |
| [Ambassador](ambassador)                                                             | Structural             | Decoupling                        |
| [API Gateway](api-gateway)                                                           | Architectural          | Cloud distributed, Decoupling     |
| [Arrange/Act/Assert](arrange-act-assert)                                             | Idiom                  | Testing                           |
| [Async Method Invocation](async-method-invocation)                                   | Concurrency            | Reactive                          |
| [Balking](balking)                                                                   | Concurrency            | Decoupling                        |
| [Bridge](bridge)                                                                     | Structural             | Gang of Four                      |
| [Builder](builder)                                                                   | Creational             | Gang of Four                      |
| [Business Delegate](business-delegate)                                               | Structural             | Decoupling                        |
| [Bytecode](bytecode)                                                                 | Behavioral             | Game programming                  |
| [Caching](caching)                                                                   | Behavioral             | Performance                       |
| [Callback](callback)                                                                 | Idiom                  | Reactive                          |
| [Chain of Responsibility](chain-of-responsibility)                                   | Behavioral             | Gang of Four                      |
| [Circuit Breaker](circuit-breaker)                                                   | Behavioral             | Performance, Decoupling           |
| [Cloud Static Content Hosting](cloud-static-content-hosting)                         | Cloud                  | Cloud distributed                 |
| [Collection Pipeline](collection-pipeline)                                           | Functional             | Reactive                          |
| [Command](command)                                                                   | Behavioral             | Gang of Four                      |
| [Composite](composite)                                                               | Structural             | Gang of Four                      |
| [Composite Entity](composite-entity)                                                 | Structural             | Enterprise Integration Pattern    |
| [Converter](converter)                                                               | Creational             | Decoupling                        |
| [Data Access Object](data-access-object)                                             | Architectural          | Data access                       |
| [Data Bus](data-bus)                                                                 | Architectural          | Decoupling                        |
| [Data Mapper](data-mapper)                                                           | Architectural          | Decoupling                        |
| [Data Transfer Object](data-transfer-object)                                         | Architectural          | Performance                       |
| [Decorator](decorator)                                                               | Structural             | Gang of Four, Extensibility       |
| [Delegation](delegation)                                                             | Structural             | Decoupling                        |
| [Dependency Injection](dependency-injection)                                         | Creational             | Decoupling                        |
| [Dirty Flag](dirty-flag)                                                             | Behavioral             | Performance, Game programming     |
| [Double Checked Locking](double-checked-locking)                                     | Idiom                  | Performance                       |
| [Facade](facade)                                                                     | Structural             | Gang of Four, Decoupling          |
| [Factory](factory)                                                                   | Creational             | Gang of Four                      |
| [Factory kit](factory-kit)                                                           | Creational             | Extensibility                     |
| [Factory Method](factory-method)                                                     | Creational             | Gang of Four, Extensibility       |
| [Interpreter](interpreter)                                                           | Behavioral             | Gang of Four                      |
| [Iterator](iterator)                                                                 | Behavioral             | Gang of Four                      |
| [Observer](observer)                                                                 | Behavioral             | Gang of Four, Reactive            |
| [Private Class Data](private-class-data)                                             | Idiom                  | Data access                       |
| [Producer Consumer](producer-consumer)                                               | Concurrency            | Reactive                          |
| [Proxy](proxy)                                                                       | Structural             | Gang of Four, Decoupling          |
| [Sharding](sharding)                                                                 | Behavioral             | Performance, Cloud distributed    |
| [State](state)                                                                       | Behavioral             | Gang of Four                      |
| [Strategy](strategy)                                                                 | Behavioral             | Gang of Four                      |
| [Template Method](table-module)                                                      | Behavioral             | Gang of Four                      |
| [Version Number](version-number)                                                     | Concurrency            | Data access, Microservices        |
| [Visitor](visitor)                                                                   | Behavioral             | Gang of Four                      |
